#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>
#include <iostream.h>
#include <fstream.h>

#include "str.h"

//#include <iostream.h>

// 砥  ப  -  ᯨ᪠ 

pair* getpair( char* s )
{

//  cout << "ࠡ⪠ ப : " << s << "\n";

  unsigned len = strlen(s);

  char tmp1[MAX_WORD], tmp2[MAX_WORD];
  char* current;
  unsigned pos;

  int escaped = 0;

  int processed = 0;
  int filling = 0;

  for (int i=0; i<len; i++ )
     {

        char c = s[i];

        if (!escaped)   // ᫨ ।騩 ᨬ -  backslash
          {
             switch (c)
                {
                   case '\\':                   //  \
                               escaped = 1;
                               break;
                   case '"':                    // "  
                               if ( !filling )
                                 {
                                    switch (processed)
                                      {
                                         case 0:
                                                  current = tmp1;
                                                  pos = 0;
                                                  break;
                                         case 1:
                                                  current = tmp2;
                                                  pos = 0;
                                                  break;
                                         case 2:
                                                  return 0; // 訡

                                      }
                                    filling = 1;
                                 }
                                else
                                  {
                                     current[pos] = 0;
                                     processed++;
                                     filling = 0;
                                  }
                               break;

                   default:
                               if ( processed>2 )  return 0;
                               if ( (!filling) && (c>32)) return 0;  // 訡

                               if (!filling) break;
                               current[pos] = c;
                               pos++;
                               if ( pos >= MAX_WORD )  return 0; // 訡
                }
          }
         else    // ।騩 ᨬ - backslash
           {
              char escapedchar;
              switch (c)
                 {
                    case '\\':
                                escapedchar = '\\';
                                break;
                    case '"':
                                escapedchar = '"';
                                break;
                    case 'n':
                                escapedchar = '\n';
                                break;
                    case 'r':
                                escapedchar = '\r';
                                break;
                    case 't':
                                escapedchar = '\t';
                                break;
                    default:
                                return 0;  // 訡
                 } 

              current[pos] = escapedchar;
              pos++;
              if ( pos >= MAX_WORD )  return 0; // 訡
              escaped = 0;

           }
     }

  if ( (processed != 2) || filling )  return 0; // 訡


  char* buf1 = new char[strlen(tmp1)+1];  // 뤥塞   2 ப
  char* buf2 = new char[strlen(tmp2)+1];
  pair* p = new pair;

  if ( (!buf1) || (!buf2) || (!p) )  assert(0);  //  墠⨫ 

  strcpy( buf1, tmp1 );
  strcpy( buf2, tmp2 );

  p->from = buf1;
  p->to = buf2;
  p->next = NULL;

//  cout << "ࠡ⪠ ப - : " << buf1 << " , " << buf2 << "\n";

  return p;

}

// ⠥  䠩 ᯨ᮪ 

int getchlist( ifstream& f, pair* &first, unsigned &maxlen )
{
  first = NULL;
  pair* p, * c;
  char buf[MAX_STR];
  unsigned line = 0,
           changes = 0;
  maxlen = 0;

  while ( !f.eof() )
    {
       line++;
       f.getline( buf, MAX_STR-1 );
//       if (!f && f.eof())
//         {
//            cout << "訡  ⥭ 䠩 !\n";
//            return 0;
//         }

       if ( strchr( buf, '"' ) && ( buf[0] != ';' ))
         {
             c = getpair( buf );

             unsigned fromlen = strlen( c->from );
             if ( fromlen > maxlen )   maxlen = fromlen;

             if ( !(c) )
               {
                  cout << "訡  ப " << line <<
                          ": " << buf << "\n";
                  return 0;
               }

             c->next = NULL;

             if (changes == 0)
                 first = c;
              else
                {
                    p->next = c;
                }
             p = c;
             changes++;
         }
    }

  return 1;
}

// ஢ ᯨ᪠  - 㥬  浪 뢠

void sortlist( pair* l )
{
  int ok = 0;
  while( !ok )
    {
      pair* p = l;
      ok = 1;
      while( p && p->next )
         {
            if ( strlen(p->from) < strlen(p->next->from) )  //   ⠬?
              {
                char* f1 = p->from,
                    * t1 = p->to,
                    * f2 = p->next->from,
                    * t2 = p->next->to;

                p->from = f2;  // 塞 ⠬
                p->to = t2;
                p->next->from = f1;
                p->next->to = t1;

                ok = 0;
              }
            p = p->next;
         }
    }
}

// 뢮 ᯨ᪠  ࠭

void dumplist( pair* l )
{
  pair* p = l;
  unsigned i=1;
  while ( p )
     {
        cout << i << ": \"" << p->from <<
          "\" -> \"" << p->to << "\"\n";
        i++;
        p = p->next;
     }
}


//  ப  ப 

void chgsubstr( pair* chlist, char* chgstr, unsigned len,
         unsigned & newlen, unsigned & used )
{
   pair* p = chlist;
   while( p )
     {
        // ࠢ ᮤন ᨢ  ப 
        unsigned lf = strlen( p->from );
        int i;
        for ( i=0; i<lf; i++ )
           {
              if ( i == len )  break;
              if ( p->from[i] != chgstr[i] )  break;
           }

        if ( i == lf )   // ப  ᮢ
          {
//             cout << ": \"" << p->from << "\" -> \"" << p->to << "\"\n";

             unsigned lt = strlen( p->to );
//             cout << "lf=" << lf << ", lt=" << lt << "\n";

             if ( lf > lt )   // ᫨ 㤥 㪮稢
               {
                  for (int z=lf-lt; z<len; z++)
                     chgstr[z-(lf-lt)] = chgstr[z];
               }
             if ( lf < lt )   // ᫨ 㤥 㤫
               {
                  for (int z=len; z>=0; z--)
                   {
//                     cout << "z = " << z << "\n";
                     chgstr[lt-lf+z] = chgstr[z];
                   }
               }

             for (int x=0; x<lt; x++)  // 㥬  ப
                chgstr[x] = p->to[x];

             newlen = len + lt - lf;
             chgstr[newlen] = 0;
             used = lt;
             return;
          }

        p = p->next;  //  ᫥饩 ப 
     }

   newlen = len;  //   뫮 - ࠡ⠫ ⮫쪮  ᨬ
   used = 1;
}

// ⥭  室 䠩 ᨬ   ப 

int readstr( ifstream &infile, char* a, unsigned maxlen, unsigned len1, unsigned& len2 )
{
    for (int i=len1; i<maxlen; i++)   // ⠥  ᨬ
      {
         char c;
         infile.get(c);
         if ( infile.eof() )
           {
              len2 = i;
              return 1;
           }
         if (!infile)
           {
              cout << "訡  ⥭ 室 䠩!\n";
              return 0;
           }
//         cout << "⠥: " << c << "\n";
         a[i] = c;
      }

    len2 = maxlen;
    return 1;
}

//   室 䠩 ᨬ  ப 

int writestr( ofstream &outfile, char* a, unsigned used, unsigned len1, unsigned& len2 )
{
    for (int i=0; i<used; i++)   // ⠥  ᨬ
      {
         outfile.put(a[i]);
//         cout << "襬: " << a[i] << "\n";
         if (!outfile)
           {
              cout << "訡    室 䠩!\n";
              return 0;
           }
      }

    for (int j=used; j<len1; j++)   //  ᤢ ⮪ ப 
      a[j-used] = a[j];

    len2 = len1 - used;
    return 1;
}

//  ᮤন 䠩

int chgfile( ifstream &infile, ofstream &outfile, pair* chglist, unsigned maxlen )
{
    char a[MAX_WORD];  // ப  
    unsigned alen = 0, alen1, used;

    while(1)
      {
         if ( !readstr( infile, a, maxlen, alen, alen1 ) )   return 0; // ⠥ ப
         alen = alen1;
//         cout << "alen=" << alen <<endl;
         if ( alen == 0 )
           {
//             outfile.close();
             return 1;
           }
         chgsubstr( chglist, a, alen, alen1, used );
         alen = alen1;
         if ( !writestr( outfile, a, used, alen, alen1 ) )  return 0; // 襬 ப;
         alen = alen1;
      }
}
